﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;

	public class Progresser extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		//SETTINGS
		private var stepper:Number = 10;
		private var separator:Number = 20;
		private var counter:Number;
		private var line:Number;
		
		public var balls:Array;
		public var obj:Object;
		
		public var ax:Number;
		public var ay:Number;
		
		public function Progresser()
		{
			balls=new Array;
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			addEventListener(Event.ENTER_FRAME, draw);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChildAt(background,0);
			drawer = new Sprite();
			counter = 0;
			line = 0;
		}
		
		private function draw(e:Event):void
		{
			if(data == null){
				setup();
			}
			counter++;
			drawer.graphics.clear();
			
			obj = {"x1":ax, "y1":ay};
			balls.push(obj);
			
			var _height:Number = stage.stageHeight/stepper;
			var _width:Number = stage.stageWidth/separator * counter;
			ax = stage.stageWidth-_width;
			ay = (line*_height)+25;
			
			//dessiner progressivement par ligne un rectangle avec alpha dépendant du séparator
			/*drawer.graphics.beginFill(0xff0000,1/separator);
			drawer.graphics.drawRect(ax,ay,_width,_height);
			drawer.graphics.endFill();*/
			
			var drop:Valur= new Valur();
					drop.x=ax;
					drop.y=ay;
					addChild(drop);
			
			
			for (var i:Number=0; i<balls.length; i++){
				if (i>200) {
					this.graphics.clear();
					var rand1:Number = Math.round(Math.random()*50);
					var rand2:Number = Math.round(Math.random()*50);
			graphics.lineStyle(2,0x000000,.9);
			graphics.beginFill(0xffffff,.4);
			graphics.moveTo(balls[i].x1, balls[i].y1);
			graphics.lineTo(balls[i-3].x1, balls[i-3].y1);
			graphics.lineTo(balls[i-23].x1, balls[i-23].y1);
			graphics.lineTo(balls[i-20].x1, balls[i-20].y1);
			graphics.lineTo(balls[i].x1, balls[i].y1);
			graphics.endFill();
				}
			}
			//dessiner dans le bmpdt
			data.draw(drawer);
			
			//condition
			if(_width >= stage.stageWidth){
				counter = 0;
				line++;
			}
			if(ay>=stage.stageHeight){
				line = 0;
			}
		}
		
	}
}

	import flash.display.Sprite;

		class Valur extends Sprite {
			function Valur() {
				graphics.beginFill(0xffffff,.3);
				graphics.lineStyle(.2,0xffffff,.3);
				graphics.drawCircle(15,0,.3);
				graphics.endFill();
		
			}
		}